#include <Wire.h>
#define SLAVE_ADDRESS 0x01 // Indirizzo 1 slave per il bus i2c
// si possono collegare insieme fino a 127 dispositivi 00 – 7F
int valore = 0; // Variabile per i dati ricevuti
char temp[5]; // Variabile temporanea char per inviare i dati float convertiti in caratteri
void setup()
{
pinMode(13, OUTPUT);
Serial.begin(9600); // Avvia la porta seriale
Wire.begin(SLAVE_ADDRESS); // Inizializza il bus i2c come slave
Wire.onReceive(receiveData); // Funzione per ricevere i dati (Callback)
Wire.onRequest(sendData); // Funzione per inviare i dati (Callback)
}
void loop() {
int lettura = analogRead(0);
float tensione = lettura * 4.8; // Prodotto della tensione di ingresso
// per lo step dell'ADC (0,0048 V = 4,8 mV)
float temperatura = tensione /= 10; // Conversione in gradi centigradi ovvero
// tensione totale diviso 10 mv per grado
Serial.println(temperatura); // Stampa la temperatura sul monitor seriale
dtostrf(temperatura, 4, 2, temp); // Converte da double a char
Wire.onRequest(sendData); // Callback per i dati inviati
delay(300); // Ritardo di 300 ms
}
void sendData() // Funzione per inviare i dati
{ Wire.write(temp); }
void receiveData(int byteCount) // Funzione per i dati ricevuti
{ while(Wire.available())
{ valore = Wire.read();
Serial.print("dati ricevuti: ");
Serial.println(valore);
if (valore == 1) digitalWrite(13, HIGH); // Accende il LED 13 (interno)
if (valore == 0) digitalWrite(13, LOW); // Spegne il LED 13 (interno)
}
}
