﻿using System;
using Windows.UI.Xaml;
using Windows.UI.Xaml.Controls;
using Windows.Devices.Spi;
using Windows.Devices.Enumeration;
using System.Diagnostics;

namespace TempSensor
{
    public sealed partial class MainPage : Page
    {
        public MainPage()
        {
            this.InitializeComponent();
            this.InitializeComponent();
            timer = new DispatcherTimer();
            timer.Interval = TimeSpan.FromMilliseconds(100);
            timer.Tick += Timer_Tick;
            timer.Start();

            InitSPI();
        }

        private async void InitSPI()
        {
            try
            {
                var settings = new SpiConnectionSettings(SPI_CHIP_SELECT_LINE);
                settings.ClockFrequency = 500000;
                settings.Mode = SpiMode.Mode0; 

                string spiAqs = SpiDevice.GetDeviceSelector(SPI_CONTROLLER_NAME);
                var deviceInfo = await DeviceInformation.FindAllAsync(spiAqs);
                SpiDisplay = await SpiDevice.FromIdAsync(deviceInfo[0].Id, settings);
            }

            catch (Exception ex)
            {
                throw new Exception("SPI Initialization Failed", ex);
            }
        }

        private void Timer_Tick(object sender, object e)
        {
            DisplayTextBoxContents();
        }

        public void DisplayTextBoxContents()
        {
            SpiDisplay.TransferFullDuplex(writeBuffer, readBuffer);
            res = ConvertToCelsius(readBuffer);
            textPlaceHolder.Text = res.ToString() + " °C";

        }

        public int ConvertToCelsius(byte[] data) // Funzione di conversione in gradi centigradi
        {
            int result = data[1] & 0x0F;
            result <<= 8;
            result += data[2];
            result /= 4;
            double step = 3.3 / 1024; // Step di lettura (tensione di riferimento 3,3 / 1024 livelli)
            double temperatura = result * step * 100; // Gradi centigradi
            result = Convert.ToInt32(temperatura); // Conversione in intero per avere i gradi senza virgola
            return result;
        }

        public int convertToInt(byte[] data)
        {
            
            int result = data[1] & 0x0F;
            result <<= 8 ;
            result += data[2];
            result /= 4;
            //Debug.WriteLine(result/4);



            double step = 3.3 / 1024;
            

            double temperature = result * step / 0.01;
            
            
            result = Convert.ToInt32(temperature);
            Debug.WriteLine(result);
            return result ;
             
        }
                
        private const string SPI_CONTROLLER_NAME = "SPI0";  /* Raspberry Pi 2, SPI0                             */
        private const Int32 SPI_CHIP_SELECT_LINE = 0;       

         byte[] readBuffer = new byte[3]; 
         byte[] writeBuffer = new byte[3] { 0x06, 0x00, 0x00 };
        
        private SpiDevice SpiDisplay;

        // timer
        private DispatcherTimer timer;
        int res;

    }
}
